//need clojure.jar in the classpath to use this.
import clojure.lang.LockingTransaction;
import clojure.lang.Ref;

public class Account  {
  private Ref balance;
  
  public Account(final int initialBalance) {
    balance = new Ref(initialBalance);
  }
  
  public void deposit(final int amount) throws Exception {
    LockingTransaction.runInTransaction(() ->
        {
          if(amount > 0) balance.set(getBalance() + amount);
          return null;
        });
    //For older versions of Java, we can use anonymous inner class of
    //Callable here instead of lambda expression.
  }
  
  public void withdraw(final int amount) throws Exception {
    LockingTransaction.runInTransaction(() -> {
      if(amount > 0 && getBalance() >= amount) {
        balance.set(getBalance() - amount);
      } else {
        throw new RuntimeException("No luck");
      }

      return null;
    });
  }

  public int getBalance() { return (Integer) balance.deref(); }
}