import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class Sample {
  public static void main(String[] args) throws InterruptedException {
    Account account1 = new Account(1000);
    Account account2 = new Account(1000);

    ExecutorService executorService = Executors.newFixedThreadPool(10);
    executorService.submit(() -> AccountService.transfer(account1, account2, 300));
    executorService.submit(() -> AccountService.transfer(account1, account2, 200));

    Thread.sleep(1000);

    System.out.println(account1.getBalance());
    System.out.println(account2.getBalance());

    executorService.shutdown();
  }
}
/*
Transfering... 300
Transfering... 200
Transfering... 300
500
1500
*/
